<template>
  <div class="favorites_container">
    <app-header></app-header>
    <div v-if="!favorites.length">No hay favoritos agregados</div>
    <div class="fav_container" v-for="(favorite, index) in favorites" :key="index">
      <div>
        <i class="fa fa-male gender" v-if="favorite.gender === 'male'"></i>
        <i class="fa fa-female gender" v-if="favorite.gender === 'female'"></i>
      </div>
      <div class="center_container">
        <div class="name_container">
          <p>{{favorite.name.title}}. {{favorite.name.first}} {{favorite.name.last}} ({{favorite.nat}})</p>
        </div>
        <p>
          <i class="fa fa-envelope icon_small"></i>
          {{favorite.email}}
        </p>
      </div>
      <div class="extra_info">
        <p>
          <i class="fa fa-birthday-cake icon"></i>
          {{ new Date(`${favorite.dob.date}`).toLocaleDateString() }}
        </p>
        <p>
          <i class="fa fa-sign-in icon"></i>
          {{ new Date(`${favorite.registered.date}`).toLocaleDateString() }}
        </p>
      </div>
      <div>
        <i :id="favorite.login.uuid" class="fa fa-times-circle icon_small" @click="removeFromFavorites"></i>
      </div>
    </div>
    <download-csv
      :data="favorites"
      name="favorites.csv"
      class="download_data"
      v-if="favorites.length"
    >Download Data</download-csv>
  </div>
</template>

<script>
import AppHeader from "../components/AppHeader";
import JsonCSV from "vue-json-csv";

import Vue from "vue";
Vue.component("downloadCsv", JsonCSV);
export default {
  name: "Favorites",
  components: { AppHeader },
  data() {
    return {
      favorites: []
    };
  },
  methods: {
    removeFromFavorites(e) {
      const trigger = e.currentTarget.id;
      this.favorites.filter(fav => {
        if (fav.login.uuid === trigger) {
          const index = this.favorites.indexOf(fav);
          if (index > -1) {
            this.favorites.splice(fav, 1);
          }
        }
      });
      localStorage.setItem("favorites", JSON.stringify(this.favorites));
    }
  },
  mounted() {
    const favorite = localStorage.getItem("favorites");
    const favoriteParsed = JSON.parse(favorite);
    this.favorites = favoriteParsed;
  }
};
</script>
<style scoped>
.favorites_container {
  margin-top: 150px;
  display: flex;
  justify-content: center;
  align-items: center;
  flex-direction: column;
}
.fav_container {
  display: flex;
  justify-content: space-between;
  width: 70%;
  align-items: center;
  box-shadow: 0 4px 2px -1px #2c3e50;
  padding: 20px;
  padding-bottom: 20px;
  margin-bottom: 40px;
}
@media all and (max-width: 768px) {
  .fav_container {
    width: 90%;
  }
}
.name_container {
  display: flex;
  font-size: 26px;
}
.download_data {
  cursor: pointer;
  background-color: rgb(231, 138, 114);
  color: white;
  padding: 20px;
  text-align: center;
  text-decoration: none;
  font-size: 16px;
  margin-top: 50px;
}
.gender {
  font-size: 36px;
}
.icon {
  font-size: 24px;
  margin-right: 10px;
}
.center_container {
  display: flex;
  flex-direction: column;
}
.icon_small {
  font-size: 20px;
  margin-right: 10px;
}
</style>
